function yy = BSplineEval(j,k,t,xx)
yy = zeros(size(xx));
if (k == 1)
  yy(t(j) <= xx & xx < t(j+1)) = 1;
else
  if (t(j+k-1) ~= t(j))
    yy = (xx-t(j))/(t(j+k-1)-t(j)).*BSplineEval(j,k-1,t,xx);
  end
  if (t(j+k) ~= t(j+1))
    yy = yy+(t(j+k)-xx)/(t(j+k)-t(j+1)).*BSplineEval(j+1,k-1,t,xx);
  end
end
if (j == length(t)-k)
  yy(xx == t(end)) = 1;
end